Name:           mined
Version:        2022.27
Release:        1%{?dist}
Summary:        Text editor with versatile unicode support

# All files are GPL-3.0-only except those in Unihan.zip which
# are under Unicode-3.0
License:        GPL-3.0-only and Unicode-3.0
URL:            https://github.com/mined/mined
Source0:        %{url}/archive/%{version}/mined-v%{version}.tar.gz
Source1:        http://www.unicode.org/Public/UNIDATA/Unihan.zip
# Replace gets with fgets
Patch:          fgets.patch

BuildRequires:  desktop-file-utils
BuildRequires:  gcc
BuildRequires:  gnulib-devel
BuildRequires:  make
BuildRequires:  ncurses-devel

%description
Mined is a powerful text editor with a comprehensive yet concise and
easy-to-use user interface supporting modern interaction paradigms,
and fast, small-footprint behaviour.

Mined provides both extensive Unicode and CJK support offering many
specific features and covering special cases that other editors are
not aware of (like auto-detection features and automatic handling of
terminal variations, or Han character information).

Mined supports full mouse control and menu system in plain-text
terminals (and it was the first editor supporting Unicode in xterm).

Mined offers a full set of text and file management features, like
data loss prevention (using backup, recovery files, and file locking
interoperable with other editors, and file change monitoring), an
interactive file chooser, and an interactive file switcher.

Basically, mined is an editor tailored to reliable and efficient
editing of plain text documents and programs, with comfortable
features and intuitive interactive behaviour designed for this purpose. 

%prep
%autosetup -p1 -n %{name}-%{version}
# Move resource into correct location
mv %{SOURCE1} src/
# Have already stored needed resource in RPM, so do not download
sed -i 's/$(WGET)/#$(WGET)/g' src/mkinclud.mak
# Ensure build flags are used for this file
sed -i 's|$(CC) -c timestmp.c|$(CC) %{build_cflags} -fPIE -c timestmp.c|g' src/mkinclud.mak
# Ensure builds on PowerPC, S390x and Aarch64
sed -i 's/_64," ; uname -m) | grep _64/64," ; uname -m) | grep -e 64 -e 390/g' src/makefile.gcc

%build
export CCFLAGS="%{build_cflags} -fPIE"
export LDFLAGS="%{build_ldflags} -pie"
%make_build


%install
%make_install
rm -r %{buildroot}/%{_datadir}/mined/package_doc
desktop-file-validate %{buildroot}/%{_datadir}/applications/mined.desktop

%files
%license LICENCE.GPL
%doc README
%doc DESCR
%{_bindir}/mined
%{_bindir}/umined
%{_bindir}/uterm
%{_bindir}/xmined
%{_bindir}/minmacs
%{_bindir}/mpico
%{_bindir}/mstar
%{_datadir}/applications/mined.desktop
%{_mandir}/man1/mined.1*
%{_mandir}/man1/minmacs.1*
%{_mandir}/man1/mpico.1*
%{_mandir}/man1/mstar.1*
%{_mandir}/man1/umined.1*
%{_mandir}/man1/uterm.1*
%{_mandir}/man1/xmined.1*
%{_datadir}/pixmaps/mined.xpm
%{_datadir}/mined/


%changelog
* Mon Mar 25 2024 Benson Muite <benson_muite@emailplus.org> - 2022.27-1
- Initial packaging
